blog/urls.py
from django.urls import path 

from . import views 

app_name="blog"
urlpatterns = [ 
    path("", views.HomeView.as_view(), name="home"),
    path("posts/search", views.PostSearchView.as_view(),name="post-search" ),
    path("posts/create", views.PostCreateView.as_view(), name="post-create"),
    path("posts/<slug:slug>/update", views.PostUpdateView.as_view(), name="post-update" ),
    path("posts/<slug:slug>/delete", views.PostDeleteView.as_view(), name="post-delete" ),
    path("posts/<slug:slug>/comment", views.CommentHandleView.as_view(), name="comment"),
    path("posts/<slug:slug>/vote", views.VoteCountView.as_view(),name="vote-count" ),
    path("posts/<slug:slug>", views.PostDetailView.as_view(), name="post-detail"),

]

blog_project/urls.py
from django.contrib import admin
from django.urls import path, include

from django.conf.urls.static import static
from django.conf import settings 

urlpatterns = [
    path('admin/', admin.site.urls),
    path("", include("blog.urls")),
    path("account/", include("account.urls")),
] + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT) + static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)

# if settings.DEBUG:
#     static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

blog/models.py
from django.db import models
from django.core.validators import MinLengthValidator,MaxLengthValidator
from django.utils.text import slugify
from django.urls import reverse 
from django.contrib.auth.models import User 


# Create your models here.

# class Author(models.Model):
#     first_name = models.CharField(max_length = 50)
#     last_name = models.CharField(max_length = 50)
#     email_address = models.EmailF

class Post(models.Model):
    title = models.CharField(max_length = 180)
    date_time = models.DateTimeField(auto_now =True)
    content = models.TextField(validators=[MinLengthValidator(10)])
    image = models.ImageField(upload_to="posts", null=True, blank=True)
    slug = models.SlugField(max_length=255,unique=True,  blank=True)
    author = models.ForeignKey(User, on_delete=models.CASCADE, related_name="posts")

    vote_count = models.PositiveIntegerField(default = 0 )
    voter = models.ManyToManyField(User)

    def save(self, *args, **kwargs): 
        self.slug = slugify(self.title)
        super().save(*args, **kwargs)

    def __str__(self):
        return f"{self.title}"

    def get_absolute_url(self):
        return reverse("blog:post-detail", kwargs={"slug": self.slug})
    
class Comment(models.Model):
    post = models.ForeignKey(Post, on_delete=models.CASCADE, related_name="comments")
    author = models.ForeignKey(User, on_delete=models.CASCADE)
    content = models.TextField(max_length = 400)
    date_time = models.DateTimeField(auto_now=True)

    def __str__(self):
        return f"{self.post.title}"

""" class Vote(models.Model):
    post = models.ForeignKey(Post, on_delete=models.CASCADE, related_name="votes")
    vote_count = models.PositiveIntegerField(default=0)
    voters_username = models.CharField(max_length=50)

    def __str__(self):
        return f"{self.post.title} - {self.vote_count}" """
 

blog/forms.py
from django import forms 

from .models import Post, Comment

class PostForm(forms.ModelForm):
    class Meta:
        model = Post 
        fields = ['title', 'content', 'image']
        widgets = {
            'title': forms.TextInput(attrs={'class': 'form-control'}),
            'content': forms.Textarea(attrs={'class': 'form-control'}),
            'image': forms.FileInput(attrs={'class': 'form-control'})
        }

class CommentForm(forms.ModelForm):
    class Meta:
        model = Comment 
        fields = ['content']
        widgets = {
            'content': forms.Textarea(attrs={"rows": "4", "class": "form-control"})
        }

blog/views.py
from typing import List
from django.shortcuts import get_object_or_404, redirect, render
from django.urls.base import reverse
from django.views.generic import TemplateView, ListView, DetailView, DeleteView, UpdateView
from django.views import View 
from django.urls import reverse_lazy
import os 
from django.db import IntegrityError
from django.contrib import messages
from django.utils.decorators import method_decorator
from django.contrib.auth.decorators import login_required
from django.core.paginator import Paginator
from django.db.models import Q

from .models import Comment, Post
from .forms import PostForm, CommentForm

# Create your views here.
class AccountMixin(object):
    def dispatch(self, request, *args, **kwargs): 
        
        if request.user.is_authenticated:
            pass 
        else:
            messages.success(request, 'User should be logged-in before performing the operation.')
            return redirect("account:login")
        return super().dispatch(request, *args, **kwargs)

class UpdateDeleteMixin(object):
    def dispatch(self, request, *args, **kwargs):  
        post_slug = self.kwargs['slug']
        post = get_object_or_404(Post, slug = post_slug)
        print(post)
        if request.user.is_authenticated:
            if request.user.id==post.author.id:
                pass 
            else:
                messages.success(request, 'Failed to perform operation. Only the post owner is authorized to upate or delete post.')
                return redirect("blog:home")
        else:
            messages.success(request, 'User should be logged-in before performing the operation.')
            return redirect("account:login")
        return super().dispatch(request, *args, **kwargs)

class HomeView(ListView):
    template_name = "blog/home.html"
    model = Post 
    context_object_name = "posts"
    ordering = ["-id"] 

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        posts = Post.objects.all().order_by("-id")
        paginator = Paginator(posts, 5, orphans=1)
        page_number = self.request.GET.get("page")
        page_obj = paginator.get_page(page_number)
        context['page_obj'] = page_obj 
        """ print("Paginator: ", paginator)
        print('Page number: ', page_number)
        print("Page_obj: ", page_obj)  """
        return context 

class PostDetailView(DetailView):
    template_name = "blog/post_detail.html"
    model = Post 
    slug_url_kwarg = 'slug' 
    context_object_name = "post"

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        if self.object.author.id==self.request.user.id:
            user_with_post = True
        else:
            user_with_post = False 
        context['comments'] = self.object.comments.all()
        context['comment_form'] = CommentForm()
        context['user_with_post'] = user_with_post
        return context


# @method_decorator(login_required, name="dispatch")
class PostCreateView(AccountMixin, View):
    def get(self, request):
        form = PostForm()
        return render(request, 'blog/post_create.html', {'form': form })

    def post(self, request):
        form = PostForm(request.POST, request.FILES) 
        if form.is_valid(): 
            try: 
                t = form.cleaned_data['title']
                c = form.cleaned_data['content']
                img = form.cleaned_data['image'] 
                post = Post(title=t, content=c, image=img, author=request.user)
                post.save()
                return redirect("blog:home")  
            except IntegrityError as e:
                messages.success(request, "Failed to save! Try with another title.")
        return render(request, 'blog/post_create.html', {'form': form })


# @method_decorator(login_required, name="dispatch")
class PostUpdateView(UpdateDeleteMixin, UpdateView):
    template_name="blog/post_update.html"
    model = Post
    form_class = PostForm
    slug_url_kwargs="slug" 

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        context['post_slug'] = self.object.slug 
        return context

    def get_success_url(self): 
        post_slug = self.object.slug 
        return reverse_lazy("blog:post-detail", kwargs={'slug': post_slug})

class CommentHandleView(AccountMixin, View):
    def post(self, request, *args, **kwargs):
        form = CommentForm(request.POST)
        if form.is_valid():
            content = form.cleaned_data['content']
            post_slug = kwargs['slug'] 
            post = Post.objects.get(slug=post_slug)
            comment= Comment(content=content, author=request.user, post=post )  
            comment.save()
        return redirect(reverse_lazy("blog:post-detail", kwargs={'slug': post_slug}))
        
class VoteCountView(View):
    def post(self, request, slug):
        try:
            post = get_object_or_404(Post, slug=slug)   
            if request.user in post.voter.all():
                post.vote_count -= 1
                post.voter.remove(request.user)
                messages.success(request, "You unvoted the post.")
            else:
                post.vote_count += 1
                post.voter.add(request.user)
                messages.success(request, 'Voting success for the post.') 
            post.save()
            # return redirect(reverse_lazy("blog:post-detail", kwargs={'slug':slug})) 
        except Exception as e:
            print(e)
        return redirect("blog:post-detail", slug=slug)

class PostSearchView(View):
    def get(self, request):
        search_text = request.GET.get('keyword').strip()
        print(search_text)
        if search_text:
            posts = Post.objects.filter(Q(title__icontains=search_text) | Q(slug__icontains=search_text) | Q(content__icontains=search_text) | Q(author__username__icontains=search_text) ).order_by('-id')
        else:
            posts = Post.objects.all().order_by('-id')
        messages.success(request, f"{len(posts)} posts found in total that contains searched text \"f{search_text}\".")
        paginator = Paginator(posts, 5, orphans=1)
        page_number = self.request.GET.get("page")
        page_obj = paginator.get_page(page_number) 
        return render(request, 'blog/post_search.html', {'page_obj': page_obj, 'search_text': search_text})

# @method_decorator(login_required, name="dispatch")
class PostDeleteView(UpdateDeleteMixin, DeleteView):
    temlate_name = "blog/post_delete.html"
    model = Post 
    success_url = reverse_lazy("blog:home")
    

blog/templates/blog/home.html
{% extends 'base.html' %}
{% load f1 %}

{% block title %}
    Blog Home
{% endblock %}

{% block content  %}
     
    <div class="row" >
        {% if request.user.is_authenticated %}
            <a href="{% url 'blog:post-create' %}" class="btn btn-primary active" style="width: 20%;">Create New Post</a>
        {% endif %}
         <p style="font-family: 'Brush Script MT', cursive; font-size:35px;" class="mt-2">All Posts</p> 
        {% if messages %}
            {% for message in messages %}
                <p class="errors">{{ message }}</p>
            {% endfor %}
        {% endif %}
        <hr>
        {% if posts %}
            {% for post in page_obj %}
                <div class="row mb-2">
                    <div class="col-lg-3">
                        <a  href="{{ post.get_absolute_url }}" class="btn btn-secondary btn-sm" >Votes: {{ post.vote_count }}</a> <a  href="{{ post.get_absolute_url }}" class="btn btn-secondary btn-sm">Comments: {{ post.comments.all|length }}</a>
                    </div>
                    <div class="col-lg-9">
                        {% comment %} <h3><a href="{% url 'post-detail' slug=post.slug %}">{{ post.title }}</a></h3> {% endcomment %}
                        <p style="display:inline; font-size:18px;" ><a href="{{ post.get_absolute_url }}">{{ post.title }}</a> <span class="text-muted" style="font-size:14px"> by</span> {{ post.author.username }} <span class="text-muted" style="font-size:14px"> on {{ post.date_time }} </span></p>
                       {% comment %}  <p>{{ post.content|content_cut:20 }}...</p> {% endcomment %}
                    </div>
                </div>
                <hr>
            {% endfor %} 
            <div>
                <span>
                    {% if page_obj.has_previous %}
                        <a href="?page={{ page_obj.previous_page_number }}" class="pagination-link btn btn-sm">Previous</a>
                    {% endif %}

                    <span class="current-page">{{ page_obj.number }}</span>
                    
                    {% if page_obj.has_next %}
                        <a href="?page={{ page_obj.next_page_number }}" class="btn btn-sm pagination-link">Next</a>
                    {% endif %}
                </span>
            </div>
        {% else %}
            <p>No posts yet!</p>
        {% endif %}
    </div>
{% endblock %}

blog/templates/blog/post_confirm_delete.html
{% extends 'base.html' %}
{% load f1 %}

{% block title %}
    Blog post delete
{% endblock %}

{% block content  %}
        <div class="row">
             <p style="font-family: 'Brush Script MT', cursive; font-size:35px;">Post Delete</p>
            <hr>
            <form method="post">
                {% csrf_token %}
                 <p style="  font-size:22px;">Do you want to delete the post "{{ object.title }}" ?</p>
                <input type="submit" value="Delete" class="btn btn-success" />
                <a href="{% url 'blog:post-detail' slug=object.slug %}" class="btn btn-warning">Cancel</a> 
            </form>   
        </div>
{% endblock %}

blog/templates/blog/post_create.html
{% extends 'base.html' %}
{% load f1 %}

{% block title %}
    Blog post create
{% endblock %}

{% block content  %} 
         <p style="font-family: 'Brush Script MT', cursive; font-size:35px;">Create Post</p>
        <hr>
        {% if messages %}
            {% for message in messages %}
                <p style="color:red;">{{ message }}</p>
            {% endfor %}
        {% endif %}
        <form action="" method="POST" novalidate enctype="Multipart/form-data">
            {% csrf_token %}
            {{ form.as_p }}
            <input type="submit" value="Create Post" class="btn btn-success"> 
            <a href="../" class="btn btn-warning">Cancel</a>
        </form> 
{% endblock %}

blog/templates/blog/post_detail.html
{% extends 'base.html' %}
{% load f1 %}

{% block title %}
    Blog post detail
{% endblock %}

{% block content  %}

        <div class="row" >
        <a href="{% url 'blog:home' %}" class="btn btn-secondary" style="width: 15%;">Back</a>
        {% if messages %}
            <div class="mt-2">
                {% for message in messages %}
                    <p style="color:green;">{{ message }}</p>
                {% endfor %}
            </div>
        {% endif %} 
            <p style="font-size:28px;" class="mt-2">{{ post.title }}</p>
            <p><span class="text-muted">by </span> <b>{{ post.author.username }}</b> <span class="text-muted">on {{ post.date_time }} </span></p> 
            <p>{{ post.content|linebreaks }}</p> 
            {% if post.image %}
                <p><img src="{{ post.image.url }}" height="330px" width="480px"></p>
            {% endif %} 
            <hr> 

            <div>
                {% if request.user.is_authenticated %}
                    <form method="POST" action="{% url 'blog:vote-count' slug=post.slug %}" class="py-2 mx-2" style="display:inline ">
                        {% csrf_token %}
                        <input type="submit" value="Vote" class="btn btn-secondary"><span style="font-family: 'Brush Script MT', cursive;">: {{ post.vote_count }}</span> 
                    </form>
                    <p style="display:inline; border: 2px solid black;border-radius: 5px"  class="py-2 px-1 mx-2" >Comments<span style="font-family: 'Brush Script MT', cursive;">: {{ post.comments.all|length }}</span></p>
                    {% if user_with_post %}
                        <a href="{% url  'blog:post-update' slug=post.slug %}" class="btn btn-primary active">Update</a>
                        <a href="{% url  'blog:post-delete' slug=post.slug %}" class="btn btn-danger active">Delete</a>
                        <hr>
                    {% endif %}
                {% endif %}
            </div>
            <h3>Comments</h3>
            {% if request.user.is_authenticated %}
                <form method="POST" action="{% url 'blog:comment' slug=post.slug %}">
                    {% csrf_token %}
                {{ comment_form.content }} {{ comment_form.content.errors|striptags }}
                    <input type="submit" value="Comment" class="btn btn-success mt-2 mb-3">
                </form>
            {% endif %}
            {% if comments %} 
                    {% for comment in comments %}
                        <p><b>{{ comment.author.username }}</b> on<span class="text-muted"> {{ comment.date_time }}</span> <br>{{ comment.content }}</p>
                    {% endfor %} 
            {% else %}
                <p>No comments yet!</p>
            {% endif %} 
            </div>
{% endblock %}

blog/templates/blog/post_search.html
{% extends 'base.html' %}
{% load f1 %}

{% block title %}
    Blog post search
{% endblock %}

{% block content  %}
     
    <div class="row" >
            
         {% if messages %}
         <div class="my-2">
            {% for message in messages %}
                <p style="color:green">{{message}}</p>
            {% endfor %}
        </div>
         {% endif %}
        {% if page_obj %}
            {% for post in page_obj %}
                <div class="row mb-2">
                    <div class="col-lg-3">
                        <a  href="{{ post.get_absolute_url }}" class="btn btn-secondary btn-sm" >Votes: {{ post.vote_count }}</a> <a  href="{{ post.get_absolute_url }}" class="btn btn-secondary btn-sm">Comments: {{ post.comments.all|length }}</a>
                    </div>
                    <div class="col-lg-9">
                        {% comment %} <h3><a href="{% url 'post-detail' slug=post.slug %}">{{ post.title }}</a></h3> {% endcomment %}
                        <p style="display:inline; font-size:18px;" ><a href="{{ post.get_absolute_url }}">{{ post.title }}</a> <span class="text-muted" style="font-size:14px"> by</span> {{ post.author.username }} <span class="text-muted" style="font-size:14px"> on {{ post.date_time }} </span></p>
                       {% comment %}  <p>{{ post.content|content_cut:20 }}...</p> {% endcomment %}
                    </div>
                </div>
                <hr>
            {% endfor %} 
            <div>
                <span>
                    {% if page_obj.has_previous %}
                        <a href="{% url 'blog:post-search' %}?keyword={{ search_text }}&page={{ page_obj.previous_page_number }}" class="pagination-link btn btn-sm">Previous</a>
                    {% endif %}

                    <span class="current-page">{{ page_obj.number }}</span>
                    
                    {% if page_obj.has_next %}
                        <a href="{% url 'blog:post-search' %}?keyword={{ search_text }}&page={{ page_obj.next_page_number }}" class="btn btn-sm pagination-link">Next</a>
                    {% endif %}
                </span>
            </div>
        {% else %}
            <p>No posts yet!</p>
        {% endif %}
    </div>
{% endblock %}

blog/templates/blog/post_update.html
{% extends 'base.html' %}
{% load f1 %}

{% block title %}
    Blog post create
{% endblock %}

{% block content  %}
        <div class="row mb-2">
         <p style="font-family: 'Brush Script MT', cursive; font-size:35px;">Update Post</p>
        <hr>
        <form action="" method="POST" novalidate enctype="Multipart/form-data">
            {% csrf_token %}
            {{ form.as_p }}
            <input type="submit" value="Update Post" class="btn btn-success">
            <a href="{% url 'blog:post-detail' slug=post_slug %}" class="btn btn-warning">Cancel</a>
        </form>
        <div> 
{% endblock %}